`ifndef COUNTER_AGENT
`define COUNTER_AGENT
class counter_agent extends uvm_agent;
	// is_active is a variable in uvm_agent
	uvm_active_passive_enum is_active = UVM_ACTIVE; 
	counter_sequencer sequencer;
	counter_driver driver;
	counter_monitor monitor;
	counter_checker m_checker;

	`uvm_component_utils_begin(counter_agent)
	`uvm_field_enum(uvm_active_passive_enum, is_active, UVM_ALL_ON)
	`uvm_component_utils_end

	function new(string name, uvm_component parent);
		super.new(name,parent);
		enable_stop_interrupt = 1;
	endfunction : new

	virtual function void build();
		super.build();
		monitor=counter_monitor::type_id::create("monitor",this);
		m_checker = counter_checker::type_id::create("m_checker",this);
		if (is_active == UVM_ACTIVE)
		begin
			driver=counter_driver::type_id::create("driver",this);
			sequencer=counter_sequencer::type_id::create("sequencer",this);
			// m_checker.counter_scoreboard(); 
		end
	endfunction : build

	virtual function void connect();   // called by environment 
		if (is_active == UVM_ACTIVE)
		begin
			driver.seq_item_port.connect(sequencer.seq_item_export);
		end
		this.monitor.m_aport.connect(this.m_checker.m_aport);
	endfunction : connect
    // Called by environment 
	virtual function void assign_vif(virtual interface counter_if vif);
		monitor.m_vif = vif;
		m_checker.m_vif= vif;
		if (is_active == UVM_ACTIVE)
		begin
			driver.vif=vif;
		end
	endfunction : assign_vif

endclass : counter_agent 
`endif
