`ifndef COUNTER_CHECKER
`define COUNTER_CHECKER

// import counter_pkg::*;
class counter_checker extends uvm_monitor; //  uvm_subscriber #(counter_xactn); // 
	
	virtual interface counter_if.mon_if_mp  m_vif;
	// int MAX_COUNT=9, MIN_COUNT=2; // parameter???
	string m_name;
	counter_xactn m_xactn;
	// implement scoreboard write method 
	uvm_analysis_imp #(counter_xactn, counter_checker) m_aport;
	// analysis_export is in uvm_subscriber
	logic[3:0] data_in; 
	logic ld; 
	logic[3:0] counter; 
	logic clk, rst_n;
	static int m_x_count, 
	m_x_pass_count, 
	m_x_fail_count;

	`uvm_component_utils_begin(counter_checker)
	`uvm_field_object(m_xactn, UVM_ALL_ON)
	`uvm_component_utils_end

	task run();
		fork
			begin
				uvm_report_info(m_name,$psprintf("%s : running",m_name),UVM_MEDIUM);
			end
//	    begin
//	        // TODO [Add process code here]
//	    end
		join
		
	endtask : run

	function new(string name, uvm_component parent);
		super.new(name,parent);
//		m_name=get_type_name();
//		m_name=m_name.toupper();
//
//		// m_xactn = new();
//		m_xactn=counter_xactn::type_id::create("m_xactn", this);  
//		m_aport = new("m_aport", this); // consider puttng in build x
	endfunction : new

	virtual function void build();
		super.build();
		m_name=get_type_name();
		m_name=m_name.toupper();

		// m_xactn = new();
		m_xactn=counter_xactn::type_id::create("m_xactn", this);  
		m_aport = new("m_aport", this); // consider puttng in build x
    		
	endfunction : build
    
	virtual function void write(counter_xactn t);
		// this.m_xactn = t;  // if(!$cast(b, rhs) || (b==null)) return;
		if(!$cast(m_xactn, t)) return; // make a copy 
		uvm_report_info ("CHKR", $sformatf("Found 1 xactn %s",
		m_xactn.sprint), UVM_MEDIUM); 
		this.check_it(this.m_xactn);
		this.counter_scoreboard ();
	endfunction : write

	virtual function void counter_scoreboard ();
		//forever begin : f_ever
		$display("counter_scoreboard started @ %t", $time); 
		// @(this.m_vif.driver_cb)
		if (this.m_vif.mon_cb.rst_n==1'b0) begin 
			$display("counter_scoreboard reset @ %t", $time);
			this.counter =MIN_COUNT;
		end
		else if (this.m_vif.mon_cb.ld) begin : load 
			if (this.m_vif.mon_cb.data_in >= MIN_COUNT && 
				this.m_vif.mon_cb.data_in <= MAX_COUNT) begin : if2
				this.counter = this.m_vif.mon_cb.data_in;
				$display("this.counter in checker=%d", this.counter); 
			end : if2
		end : load 
		else if(this.counter==MAX_COUNT) 
			this.counter = this.counter + 1'b0; 
		else this.counter = this.counter + 1'b1;
		// end : f_ever
	endfunction : counter_scoreboard

	virtual function void check_it(counter_xactn xactn);
		//if (this.counter != xactn.data_collected)
		if (this.counter != m_vif.mon_cb.counter)
			uvm_report_error( 
			"CHKR", $sformatf("FAILED: counter=%d, expected=%d", 
			// m_vif.driver_cb.counter, this.counter));
			xactn.data_collected, this.counter)); // xactn.data_collected, this.counter), UVM_NONE);
		else uvm_report_info( 
			"CHKR", $sformatf("PASSED: counter=%d, expected=%d", 
			// m_vif.driver_cb.counter, this.counter));
			xactn.data_collected, this.counter));
	endfunction : check_it

endclass : counter_checker 
`endif
