`ifndef COUNTER_MONITOR
`define COUNTER_MONITOR

class counter_monitor extends uvm_monitor;
	string m_name;
	virtual interface counter_if.mon_if_mp m_vif;
	counter_xactn m_xactn;
	//TLM port for scoreboard communication 
	// (implement scoreboard write method if needed)
	uvm_analysis_port #(counter_xactn) m_aport;
	`uvm_component_utils_begin(counter_monitor)
	`uvm_field_object(m_xactn, UVM_ALL_ON)
	`uvm_component_utils_end  
    
	task collect_data();
		forever
		begin
			@(this.m_vif.mon_cb);
			//wait (this.m_vif.mon_cb.mon_data_valid === 1'b1 );
			m_xactn.data_collected = m_vif.mon_cb.counter;
			m_xactn.data = m_vif.mon_cb.data_in;
			m_xactn.ld = m_vif.mon_cb.ld;
			m_xactn.rst_n = m_vif.mon_cb.rst_n;
			m_xactn.kind = m_vif.mon_cb.kind_cp; 
			uvm_report_info(m_name,
			$sformatf("%s : MON collected: %0s",m_name, 
			m_xactn.sprint()),UVM_LOW);
        
			//post good m_xactn to Analysis port 
			m_aport.write(m_xactn);
		end;
	endtask : collect_data

	task run();
		fork
			begin
				// counter_cvg : cntr_cvg;
				uvm_report_info(m_name,$psprintf("%s : running",m_name),UVM_MEDIUM);
			end
			begin
				collect_data();
			end
		join
	endtask : run

	function new(string name, uvm_component parent);
		super.new(name,parent);
		m_name=get_type_name();
		m_name=m_name.toupper();

		// m_xactn = new();
		m_xactn=counter_xactn::type_id::create("m_xactn", this);  
		m_aport = new("m_aport", this);
	endfunction : new

endclass : counter_monitor 
`endif
