`ifndef COUNTER_MONITOR_CVG
`define COUNTER_MONITOR_CVG
class counter_monitor_cvg extends counter_monitor; // must be extention for factory
	string m_name;
	// virtual interface counter_if.mon_if_mp m_vif;
	counter_xactn m_xactn;
	//TLM port for scoreboard communication 
	// (implement scoreboard write method if needed)
	// uvm_analysis_port #(counter_xactn) m_aport;

	//`uvm_object_utils_begin(counter_monitor_cvg)
	`uvm_component_utils_begin(counter_monitor_cvg)
	`uvm_field_object(m_xactn, UVM_ALL_ON)
	`uvm_component_utils_end
	//`uvm_object_utils_end
	
    
	// covergroup cntr_cvg @(this.m_vif.mon_cb);  
	covergroup cntr_cvg; // did not like the "this."
//		type_option.merge_instances = 0;
//		option.per_instance = 1;
//		option.get_inst_coverage = 1;
//		option.comment = "counter values";
//		option.name="counter_legal_illegal"; 
		cntr: coverpoint m_xactn.data_collected {
			bins legal = {[3:6]}; // { [0:63] }; {0,50};
			bins illegal_low = {[0:2]};
			bins illegal_hi = {[7:15]};
		}
		d_in: coverpoint m_xactn.data {
			bins legal = {[3:6]}; // { [0:63] }; {0,50};
			bins illegal_low = {[0:2]};
			bins illegal_hi = {[7:15]};
		} 
	endgroup : cntr_cvg
        
	task collect_data_for_cvg();
		forever
		begin
			@(this.m_vif.mon_cb);
			//wait (this.m_vif.mon_cb.mon_data_valid === 1'b1 );
			m_xactn.data_collected = m_vif.mon_cb.counter;
			m_xactn.data = m_vif.mon_cb.data_in;
			m_xactn.ld = m_vif.mon_cb.ld;
			m_xactn.rst_n = m_vif.mon_cb.rst_n;
			m_xactn.kind = m_vif.mon_cb.kind_cp; 
  			$display ("%0t %s Triggering Coverage sampling via sample()",$time, "counter_monitor_cvg");
			this.cntr_cvg.sample(); 
		end;
	endtask : collect_data_for_cvg

//	function void post_randomize () ;
//		$display ("%0t %s Triggering Coverage sampling via sample()",$time, "counter_monitor_cvg");
//		this.cntr_cvg.sample(); 
//	endfunction : post_randomize 
	task run();
		fork
			begin
				super.run();  // To collect data for the checker in counter_monitor
				uvm_report_info(m_name,$psprintf("%s : running",m_name),UVM_MEDIUM);
			end
			begin
				collect_data_for_cvg();
			end
		join
		
		
	endtask : run
	
	virtual function void build();
		super.build();
		//m_xactn = new();
		m_xactn=counter_xactn::type_id::create("m_xactn", this);  
		// this.cntr_cvg = new();   // <<*** ILLEGAL ******
	endfunction : build

	function new(string name, uvm_component parent);
		super.new(name,parent);
		m_name=get_type_name();
		m_name=m_name.toupper();
//		m_xactn=counter_xactn::type_id::create("m_xactn", this);  
		this.cntr_cvg = new();
	endfunction : new

endclass : counter_monitor_cvg 
`endif

