//----------------------------------------------------------------------
//                   Mentor Graphics Corporation
//----------------------------------------------------------------------
// Project         : counter
// Unit            : trans
// File            : trans.svh
//----------------------------------------------------------------------
// Created by      : ben2
// Creation Date   : 2011/08/12
//----------------------------------------------------------------------
// Title: 
//
// Summary:
//
// Description:
//
//----------------------------------------------------------------------
// /UVM_counter_with_resp0/tb_src/counter_xactn.sv
`ifndef COUNTER_XACTN
`define COUNTER_XACTN
class counter_xactn extends uvm_sequence_item;
	rand logic[3:0] data=0;
	logic[3:0] data_collected, data_viewed; 
	rand logic ld=0, rst_n;
	rand int reset_cycles, idle_cycles=1;
	rand int xx;
	rand ct_scen_e kind;
	// factory registration macro
	`uvm_object_utils_begin(counter_xactn)
//	`uvm_field_int(data, UVM_ALL_ON)
//	`uvm_field_int(data_collected, UVM_ALL_ON | UVM_UNSIGNED)
//	`uvm_field_int(data_viewed, UVM_ALL_ON)
//	`uvm_field_int(ld, UVM_ALL_ON | UVM_UNSIGNED)
//	`uvm_field_int(rst_n, UVM_ALL_ON)
//	`uvm_field_int(reset_cycles, UVM_ALL_ON)
//	`uvm_field_int(idle_cycles, UVM_ALL_ON | UVM_DEFAULT | UVM_BIN)
//	`uvm_field_int(xx, UVM_ALL_ON)
//	`uvm_field_enum(ct_scen_e, kind, UVM_ALL_ON | UVM_DEFAULT)
	`uvm_object_utils_end

	//constraint values { ld dist {1'b0 := 80, 1'b1 := 20}; } // 0 80% of time
	constraint cst_data_range { data > 2 && data <=9; } 
	constraint cst_reset {
		reset_cycles inside {[1:10]}; 
	} 
	constraint cst_idle {
		idle_cycles > 1 && idle_cycles <=3; 
	} 
    
	constraint cst_xact_kind {
		kind dist {
			CT_LOAD := 20, 
			CT_RESET := 10, 
			CT_WAIT := 68,
			CT_DONE := 2
		};
	} // cst_xact_kind
    
	//--------------------------------------------------------------------
	// new
	//--------------------------------------------------------------------
	function new (string name = "counter_xactn" );
		super.new(name);
	endfunction: new
    
	//--------------------------------------------------------------------
	// do_print
	//--------------------------------------------------------------------
	function void do_print(uvm_printer printer);
		if(printer.knobs.sprint == 0) begin
			$display(convert2string());
		end
		else begin
			printer.m_string = convert2string();
		end
	endfunction: do_print

	//--------------------------------------------------------------------
	// convert2string
	//--------------------------------------------------------------------
	function string convert2string();
		string str;
		str = super.convert2string();
		$sformat(str, "%s \n",str);
		$sformat(str, "%s kind: \t%0d\n", str, this.kind.name); //bc
		$sformat(str, "%s data: \t%0d\n", str, this.data); //bc
		//$sformat(str, "%s data_collected: \t%0d\n", str, this.data_collected); //bc
		//        $sformat(str, "%s idle_cycles: \t%0d\n", str, this.idle_cycles); //bc
		//        $sformat(str, "%s reset_cycles: \t%0d\n", str, this.reset_cycles); //bc      
		return str;
	endfunction: convert2string


endclass: counter_xactn

`endif

