//----------------------------------------------------------------------
//                   Mentor Graphics Corporation
//----------------------------------------------------------------------
// Project         : counter
// Unit            : trans
// File            : trans.svh
//----------------------------------------------------------------------
// Created by      : ben2
// Creation Date   : 2011/08/12
//----------------------------------------------------------------------
// Title: 
//
// Summary:
//
// Description:
//
//----------------------------------------------------------------------

`ifndef COUNTER_XACTN_RAND
`define COUNTER_XACTN_RAND

//----------------------------------------------------------------------
// trans
//----------------------------------------------------------------------
// import counter_pkg::*; 
class counter_xactn_rand extends counter_xactn;
	
//    rand logic[3:0] data=0;
//    logic[3:0] data_collected, data_viewed; 
//    rand logic ld=0, rst_n;
//    rand int reset_cycles, idle_cycles=1;
    //constraint values { ld dist {1'b0 := 80, 1'b1 := 20}; } // 0 80% of time
    constraint cst_data_range { data >= 0 && data <=15; } 
    
    //rand ct_scen_e kind;
    
    constraint cst_reset {
        reset_cycles inside {[1:10]}; 
    } 
    constraint cst_idle {
        idle_cycles > 1 && idle_cycles <=2; 
    } 
    
    constraint cst_xact_kind {
        kind dist {
            CT_LOAD := 40,
            CT_RESET := 5, 
            CT_WAIT := 35,
            CT_DONE := 20
        };
    } // cst_xact_kind
    
    // factory registration macro
    
    `uvm_object_utils_begin(counter_xactn_rand)
        `uvm_field_int(data , UVM_ALL_ON)
        `uvm_field_int(ld, UVM_ALL_ON)
        //        `uvm_field_int(pkt_len , OVM_ALL_ON)
        //        `uvm_field_int(pkt_pld, OVM_ALL_ON)
        //        `uvm_field_int(exp_data_for_checker, OVM_ALL_ON)
        //        `uvm_field_int(ipg, OVM_ALL_ON)
        `uvm_field_enum (ct_scen_e, kind, UVM_ALL_ON )
    `uvm_object_utils_end
    // `uvm_component_utils(counter_xactn_rand) // <<<< multiply defined.
    //--------------------------------------------------------------------
    // new
    //--------------------------------------------------------------------
    function new (string name = "counter_xactn_rand" );
        super.new(name);
    endfunction: new
    
    //--------------------------------------------------------------------
    // do_print
    //--------------------------------------------------------------------
    function void do_print(uvm_printer printer);
        if(printer.knobs.sprint == 0) begin
            $display(convert2string());
        end
        else begin
            printer.m_string = convert2string();
        end
    endfunction: do_print

    //--------------------------------------------------------------------
    // convert2string
    //--------------------------------------------------------------------
    function string convert2string();
        string str;
        str = super.convert2string();
        $sformat(str, "%s \n",str);
        $sformat(str, "%s kind: \t%0d\n", str, this.kind.name); //bc
        $sformat(str, "%s data: \t%0d\n", str, this.data); //bc
        //$sformat(str, "%s data_collected: \t%0d\n", str, this.data_collected); //bc
        //        $sformat(str, "%s idle_cycles: \t%0d\n", str, this.idle_cycles); //bc
        //        $sformat(str, "%s reset_cycles: \t%0d\n", str, this.reset_cycles); //bc      
        return str;
    endfunction: convert2string


endclass: counter_xactn_rand

`endif

