`ifndef COUNTER_BASE_TEST
`define COUNTER_BASE_TEST

class counter_base_test extends uvm_test;
	`uvm_component_utils(counter_base_test)
  
	counter_env env_0;
	uvm_sequencer #(counter_xactn, counter_xactn) m_test_sequencer;

	function new(string name, uvm_component parent);
		super.new(name,parent);
	endfunction : new

	virtual function void build();
		super.build();
		env_0 = counter_env::type_id::create("env_0",this);
		// set_config_int("env_0.agent0","is_active",UVM_ACTIVE);
		//**uvm_resource_db#(int)::set("env_0.agent0","is_active",UVM_ACTIVE, this);
		// uvm_config_db#(int)::set(this, "*", "A");
		// uvm_resource_db#(int)::set("A", "*", 17, this);
	endfunction : build

	task run();
//        `message(UVM_LOW,("Test is running..."))
		uvm_report_info(get_name(),"Test is running...");
		uvm_top.print_topology();
		#1000000 
		//delay is simple "end of test" mechanism
		//use objections in sequences for better "end of test" detection
//        `message(UVM_LOW,("User activated end of simulation"))
		uvm_report_info(get_name(),"User activated end of simulation");
		global_stop_request();
	endtask : run
    
	virtual function void connect();
		//Find the actual sequencer
		m_test_sequencer = env_0.agent0.sequencer;
	endfunction: connect
    

endclass : counter_base_test 
`endif
