`ifndef COUNTER_SEQ1
`define COUNTER_SEQ1

class counter_seq1 extends uvm_sequence #(counter_xactn);
	string tID;
	//`uvm_sequence_utils(counter_seq1,counter_sequencer)
	//`uvm_component_utils(counter_seq1)
	`uvm_object_utils(counter_seq1)
	//counter_xactn trans;
	//"req" built-in uvm_sequence class member for sequence_item
	rand int delay1;
	rand int delay2;
	constraint d1 {delay1>55; delay1<125;}
	constraint d2 {delay2>25; delay2<45;}

	function new(string name = "counter_seq1");
		super.new(name);
		tID=get_type_name();
		tID=tID.toupper();
	endfunction : new

	virtual task pre_body();
		super.pre_body(); 
		uvm_test_done.raise_objection(this);
	endtask

// Drop the objection in the post_body so the objection is removed when
// the root sequence is complete. 
	virtual task post_body();
		super.post_body();
		uvm_test_done.drop_objection(this);
	endtask

	task body();
		uvm_report_info(tID,$sformatf("%s : sequence Running",tID),UVM_LOW);
		//not the best way to print, just to confirm randomization
		uvm_report_info(tID,$sformatf("%s : delay1=%0d, delay2=%0d", tID, delay1, delay2),UVM_MEDIUM);
		// CT_LOAD, CT_RESET, CT_WAIT, CT_DONE
		// ** Error: (vsim-3043) ../tests/counter_seq_with_rst.sv(23): 
		// Unresolved reference to 'env_0' in env_0.agent0.m_checker.MAX_COUNT.
//               #         Region: /top/counter_seq1
//        ovm_report_info(tID,$sformatf("%s : setting MAX MIN counts in checker",tID),OVM_LOW);
//        env_0.agent0.m_checker.MAX_COUNT=6; // top.MAX_COUNT_TB; 
//        env_0.agent0.m_checker.MIN_COUNT=3;
                	
		`uvm_do_with(req, {this.kind == CT_WAIT;} ) //this line sends the transaction
		`uvm_do_with(req, {this.kind == CT_RESET;} ) //this line sends the transaction
		//#delay1 //dummy delay to illustrate a sequence rand variable
		`uvm_do_with(req, {this.kind == CT_LOAD;} ) //this line sends the transaction
		//#delay1
		`uvm_do_with(req, {this.kind == CT_WAIT;} ) //this line sends the transaction
		repeat(50) `uvm_do(req)
		//#delay1
		`uvm_do_with(req, {this.kind == CT_DONE;} ) //this line sends the transaction
		//#delay2
		uvm_report_info(tID,$psprintf("sequence : %s complete",tID),UVM_LOW);
		global_stop_request();
	endtask : body

endclass : counter_seq1 
`endif
//additional sequences can be included in this file

