import uvm_pkg::*;
`include "uvm_macros.svh"

module top();
    // timeunit 1ns; timeprecision 100ps;
    import counter_pkg::*;
`include "counter_inc.svh"
`include "rand_test.sv"
`include "counter_sequence1c.svh"
`include "counter_sequence2.svh"
`include "counter_rand_seq.svh"
`include "test1.svh"
`include "test2.svh"
`include "test1_ovride.svh"
`include "rand_test_sq.svh"
`include "simple_test.sv"
    // const int MAX_COUNT_TB=MAX_COUNT, MIN_COUNT_TB=MIN_COUNT; 
    logic[3:0] data_in=0, data=0;
    logic ld=0;
    logic[3:0] counter;
    logic clk=1'b1, rst_n;
    
    covergroup counter_cvg @(posedge clk); // 
        //type_option.merge_instances = 0;
        // option.per_instance = 1;
        //option.get_inst_coverage = 1;
        //option.comment = "counter values";
        //option.name="counter_legal_illegal"; 
        cntr: coverpoint if0.counter {
            bins legal = {[3:6]}; // { [0:63] }; {0,50};
            bins illegal_low = {[0:MIN_COUNT-1]};
            bins illegal_hi = {[MAX_COUNT+1:15]};
        }
        d_in: coverpoint if0.data_in {
            bins legal = {[3:6]}; // { [0:63] }; {0,50};
            bins illegal_low = {[0:MIN_COUNT-1]};
            bins illegal_hi = {[MAX_COUNT+1:15]};
        } 
    endgroup : counter_cvg
    
    counter_cvg cntr_cvg0; 
    
    // always @ (posedge clk) cntr_cvg0.sample(); 

    counter_if if0(.clk (clk) ); //instantiate ovc interface

    // counter_max #(.MAX_COUNT(MAX_COUNT_TB), .MIN_COUNT(MIN_COUNT_TB)) 
    // counter_max1(
    counter_max counter_max1(
    .data_in(if0.data_in),
    .ld(if0.ld), 
    .counter(if0.counter), 
    .clk(clk), 
    .rst_n(if0.rst_n)); 
    
    initial
    begin
        cntr_cvg0=new();
        run_test();
    end

    initial
    begin : cgen
        // clk = 1'b1;
        forever #10 clk <= ~clk;
    end : cgen

//    initial
//    repeat (50) begin @(posedge clk);
//        $finish; 
//    end
    
endmodule
